/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "main.h"
#include "interface.h"
#include "support.h"

int
main (int argc, char *argv[])
{

  gnome_program_init (PACKAGE, VERSION, LIBGNOMEUI_MODULE,
                      argc, argv,
                      GNOME_PARAM_APP_DATADIR, PACKAGE_DATA_DIR,
                      NULL);
                      
  my_colormap = gdk_colormap_get_system ();
  
  gdk_color_parse("black",&black);
  gdk_color_parse("white",&white);
  gdk_color_parse("yellow",&yellow);
  gdk_color_parse("green",&green);
  gdk_color_parse("magenta",&magenta);
  gdk_color_parse("cyan",&cyan);
  gdk_color_parse("red",&red);
  gdk_color_parse("blue",&blue);
  gdk_colormap_alloc_color(my_colormap,&black,FALSE,FALSE);
  gdk_colormap_alloc_color(my_colormap,&white,FALSE,FALSE);
  gdk_colormap_alloc_color(my_colormap,&yellow,FALSE,FALSE);
  gdk_colormap_alloc_color(my_colormap,&green,FALSE,FALSE);
  gdk_colormap_alloc_color(my_colormap,&magenta,FALSE,FALSE);
  gdk_colormap_alloc_color(my_colormap,&cyan,FALSE,FALSE);
  gdk_colormap_alloc_color(my_colormap,&red,FALSE,FALSE);
  gdk_colormap_alloc_color(my_colormap,&blue,FALSE,FALSE);
  my_font = pango_font_description_from_string("Courier 12");

  /*
   * The following code was added by Glade to create one of each component
   * (except popup menus), just so that you see something after building
   * the project. Delete any components that you don't want shown initially.
   */
  main_window = create_main_window ();
  gtk_widget_show (main_window);

  gtk_main ();
  return 0;
}

gboolean    network_read        (	GIOChannel *source,
                                    GIOCondition condition,
                                    gpointer data)
{
	gchar buff[1025];
	int read_bytes = 1024;
	int got_bytes;
	gint local_data = GPOINTER_TO_INT(data);
	GtkAdjustment *vadj = gtk_scrolled_window_get_vadjustment(GTK_SCROLLED_WINDOW(WorldList[(int)local_data].output_scroller));
	gint lastcalc, value;

	gtk_text_buffer_get_end_iter(gtk_text_view_get_buffer(GTK_TEXT_VIEW(WorldList[(int)local_data].output_text)), &WorldList[(int)local_data].output_end_iter);
	
	got_bytes = recv(g_io_channel_unix_get_fd (source), buff, read_bytes, 0);

	if (got_bytes > 0) {
		gM_world_print(local_data, buff, got_bytes);

		// This is to make sure the window scrolls to the bottom when new input is recieved.
		do {
			gtk_adjustment_set_value(vadj, vadj->upper - vadj->page_size);
			value = vadj->value;
			lastcalc = vadj->upper - vadj->page_size;
		} while (lastcalc != value);

		return TRUE;
	} else {
		gdk_input_remove(WorldList[(int)local_data].network_read_handler);
		return FALSE;
	}
}

gboolean scroll_history (	GtkTextBuffer *editable,
						GdkEvent *Event,
						gpointer user_data)
{
	gpointer myCommand;
	gchar *all_text;
	GtkTextIter startpos, endpos;
	
	gtk_text_buffer_get_start_iter(gtk_text_view_get_buffer(GTK_TEXT_VIEW(editable)),&startpos);
	gtk_text_buffer_get_end_iter(gtk_text_view_get_buffer(GTK_TEXT_VIEW(editable)),&endpos);
	
	if (Event->key.keyval == 65365) {
		WorldList[WorldListIndex].historyindex = WorldList[WorldListIndex].historyindex - 1;
		all_text = gtk_text_buffer_get_text(gtk_text_view_get_buffer(GTK_TEXT_VIEW(editable)), &startpos, &endpos, FALSE);
		if ((WorldList[WorldListIndex].historyindex + 1 == g_list_length(WorldList[WorldListIndex].command_history))) {
			g_string_sprintf(WorldList[WorldListIndex].storedcommand,"%s",all_text);
		}
		myCommand = g_list_nth_data(WorldList[WorldListIndex].command_history,WorldList[WorldListIndex].historyindex);
		if (myCommand) {
			gtk_text_buffer_delete(gtk_text_view_get_buffer(GTK_TEXT_VIEW(WorldList[WorldListIndex].input_text)), &startpos, &endpos);
			gtk_text_buffer_insert(gtk_text_view_get_buffer(GTK_TEXT_VIEW(WorldList[WorldListIndex].input_text)), &endpos, _((gchar *)myCommand), -1);
		}
		if (WorldList[WorldListIndex].historyindex < 0) { WorldList[WorldListIndex].historyindex = 0; }
	} else if (Event->key.keyval == 65366) {
		WorldList[WorldListIndex].historyindex = WorldList[WorldListIndex].historyindex + 1;
		myCommand = g_list_nth_data(WorldList[WorldListIndex].command_history,WorldList[WorldListIndex].historyindex);
		if (myCommand) {
			gtk_text_buffer_delete(gtk_text_view_get_buffer(GTK_TEXT_VIEW(WorldList[WorldListIndex].input_text)), &startpos, &endpos);
			gtk_text_buffer_insert(gtk_text_view_get_buffer(GTK_TEXT_VIEW(WorldList[WorldListIndex].input_text)), &endpos, _((gchar *)myCommand), -1);
		} else {
			gtk_text_buffer_delete(gtk_text_view_get_buffer(GTK_TEXT_VIEW(WorldList[WorldListIndex].input_text)), &startpos, &endpos);
			if (WorldList[WorldListIndex].storedcommand->str && g_strcasecmp(WorldList[WorldListIndex].storedcommand->str,"") != 0) {
				gtk_text_buffer_insert(gtk_text_view_get_buffer(GTK_TEXT_VIEW(WorldList[WorldListIndex].input_text)), &endpos, _(WorldList[WorldListIndex].storedcommand->str), -1);
			}
		}
		if (WorldList[WorldListIndex].historyindex > g_list_length(WorldList[WorldListIndex].command_history)) { WorldList[WorldListIndex].historyindex = g_list_length(WorldList[WorldListIndex].command_history); }
	}
	return FALSE;
}

void catch_input (GtkTextBuffer *editable,
                        gpointer arg1,
                        gpointer new_text,
                        gint arg3,
                        gboolean arg4,
                        gpointer user_data)
{
	gchar *all_text;
	gchar *send_text;
	GtkTextIter endpos, startpos;
	gint endpos2;
	gint mylistindex = 0;
    gint total = 0;        // how many bytes we've sent
    gint bytesleft = 0; // how many we have left to send
	gint n = 0;
	GtkAdjustment *vadj = gtk_scrolled_window_get_vadjustment(GTK_SCROLLED_WINDOW(WorldList[WorldListIndex].output_scroller));
	gint lastcalc, value;

	gtk_text_buffer_get_start_iter(editable,&startpos);
	gtk_text_buffer_get_end_iter(editable,&endpos);

	if (*(char *)new_text == '\n') {
		bytesleft = gtk_text_iter_get_offset(&endpos);
		endpos2 = bytesleft - 1;
		all_text = gtk_text_buffer_get_text(editable, &startpos, &endpos, FALSE);

		if (all_text && endpos2 != 0) {
			while (total < (endpos2 + 1))
			{
				n = send(WorldList[WorldListIndex].sockfd, all_text+total, bytesleft, 0);
				if (n == -1)
				{
					perror("send");
					break;
				}
				total += n;
				bytesleft -= n;
			}

			gtk_text_buffer_insert (gtk_text_view_get_buffer(GTK_TEXT_VIEW(WorldList[WorldListIndex].output_text)), &WorldList[WorldListIndex].output_end_iter, _(all_text), -1);
			gtk_text_buffer_insert (gtk_text_view_get_buffer(GTK_TEXT_VIEW(WorldList[WorldListIndex].output_text)), &WorldList[WorldListIndex].output_end_iter, _("\n"), 1);
			WorldList[WorldListIndex].command_history = g_list_append(WorldList[WorldListIndex].command_history,(gpointer)all_text);

			if (WorldList[WorldListIndex].command_history) {
				mylistindex = g_list_length(WorldList[WorldListIndex].command_history);
			} else {
				mylistindex = 0;
			}
			if (g_strcasecmp((gchar *)g_list_nth_data(WorldList[WorldListIndex].command_history,mylistindex-1),all_text) != 0) {
				WorldList[WorldListIndex].command_history = g_list_append(WorldList[WorldListIndex].command_history,(gpointer)all_text);
			}
			if (WorldList[WorldListIndex].command_history) {
				WorldList[WorldListIndex].historyindex = g_list_length(WorldList[WorldListIndex].command_history);
			}
		}
		gtk_text_buffer_delete(editable, &startpos, &endpos);
	}

	// This is to make sure the window scrolls to the bottom when new input is recieved.
	do {
		gtk_adjustment_set_value(vadj, vadj->upper - vadj->page_size);
		value = vadj->value;
		lastcalc = vadj->upper - vadj->page_size;
	} while (lastcalc != value);
}

void create_tags(GtkTextBuffer *buffer) {
	gtk_text_buffer_create_tag(buffer,"black_background","background","black",NULL);
	gtk_text_buffer_create_tag(buffer,"white_background","background","white",NULL);
	gtk_text_buffer_create_tag(buffer,"black_foreground","foreground","black",NULL);
	gtk_text_buffer_create_tag(buffer,"white_foreground","foreground","white",NULL);

	gtk_text_buffer_create_tag(buffer,"red_background","background","red",NULL);
	gtk_text_buffer_create_tag(buffer,"blue_background","background","blue",NULL);
	gtk_text_buffer_create_tag(buffer,"red_foreground","foreground","red",NULL);
	gtk_text_buffer_create_tag(buffer,"blue_foreground","foreground","blue",NULL);

	gtk_text_buffer_create_tag(buffer,"yellow_background","background","yellow",NULL);
	gtk_text_buffer_create_tag(buffer,"green_background","background","green",NULL);
	gtk_text_buffer_create_tag(buffer,"yellow_foreground","foreground","yellow",NULL);
	gtk_text_buffer_create_tag(buffer,"green_foreground","foreground","green",NULL);

	gtk_text_buffer_create_tag(buffer,"magenta_background","background","magenta",NULL);
	gtk_text_buffer_create_tag(buffer,"cyan_background","background","cyan",NULL);
	gtk_text_buffer_create_tag(buffer,"magenta_foreground","foreground","magenta",NULL);
	gtk_text_buffer_create_tag(buffer,"cyan_foreground","foreground","cyan",NULL);

	gtk_text_buffer_create_tag(buffer,"bold_weight","weight",PANGO_WEIGHT_BOLD,NULL);
	gtk_text_buffer_create_tag(buffer,"normal_weight","weight",PANGO_WEIGHT_NORMAL,NULL);
}

#define insert_current()\
		print_start_offset = gtk_text_iter_get_offset (&WorldList[myIndex].output_end_iter);\
		gtk_text_buffer_insert (gtk_text_view_get_buffer(GTK_TEXT_VIEW(WorldList[myIndex].output_text)), &WorldList[myIndex].output_end_iter, _(s), j);\
		gtk_text_buffer_get_iter_at_offset (gtk_text_view_get_buffer(GTK_TEXT_VIEW(WorldList[myIndex].output_text)),&print_start_iter,print_start_offset);\
		gtk_text_buffer_apply_tag_by_name (gtk_text_view_get_buffer(GTK_TEXT_VIEW(WorldList[myIndex].output_text)),WorldList[myIndex].fgcolor,&print_start_iter,&WorldList[myIndex].output_end_iter);\
		gtk_text_buffer_apply_tag_by_name (gtk_text_view_get_buffer(GTK_TEXT_VIEW(WorldList[myIndex].output_text)),WorldList[myIndex].bgcolor,&print_start_iter,&WorldList[myIndex].output_end_iter);\
		gtk_text_buffer_apply_tag_by_name (gtk_text_view_get_buffer(GTK_TEXT_VIEW(WorldList[myIndex].output_text)),WorldList[myIndex].font_weight,&print_start_iter,&WorldList[myIndex].output_end_iter);
//        write_log(myIndex, s)

void add_10_if_needed(gint myIndex) {
  char *tmp;
  gchar *name;

  if(WorldList[myIndex].insert_10 == 1) {
    /* Update the line(count) label if required */
    if(WorldListIndex != myIndex) {
      WorldList[myIndex].lines_pending++;
	  gtk_widget_modify_text(WorldList[myIndex].world_name,GTK_STATE_NORMAL,&red);
      if(WorldList[myIndex].lines_pending > 1) {
        tmp = g_malloc(strlen((char *)WorldList[myIndex].DisplayName->str) + 30);
        name = g_malloc(21);

  			limit_to_20(FOR_WORLD, WorldList[myIndex].DisplayName->str, &name);
        sprintf(tmp, "%s [%d]", WorldList[myIndex].DisplayName->str, WorldList[myIndex].lines_pending);
        gtk_label_set_text(GTK_LABEL(WorldList[myIndex].world_name), tmp);
        g_free(name);
        g_free(tmp);
      }
    }
  }
  WorldList[myIndex].insert_10 = 0;
}

void gM_world_print(gint myIndex, char *line, int len) {
  int i,j;
  char *s;
  GtkAdjustment *vadj = gtk_scrolled_window_get_vadjustment (GTK_SCROLLED_WINDOW(WorldList[myIndex].output_scroller));
  int napos = 0;  /* non ansi position, used by the highliter */
  GtkTextIter print_start_iter;
  gint print_start_offset;

  if(line == NULL)
    return;

  if(len < 0)
    len = strlen(line);

  s = g_malloc(len + 1);
  j = 0;
  
  for(i = 0; i < len; i++) {
    if(WorldList[myIndex].highlites != NULL) { 
#ifdef DEBUG
printf("*** Highlighting the text\n");
#endif
      if(j != 0) {
        s[j] = 0;
        add_10_if_needed(myIndex);
        insert_current();
        j = 0;
      }
//      while(napos < WorldList[myIndex].highlitecount && WorldList[myIndex].highlites[napos] != -1) {
//        parse_print_trigger(WorldList[myIndex], line, &i, &napos, len);
//      }
    }
    switch(line[i]) {
    case -1:
      if(i + 2 < len && line[i + 2] == 1) {
        if(line[i + 1] == -5) /* echo off */
          WorldList[myIndex].force_no_echo = 1;
        else if(line[i + 1] == -4) /* echo back on */
          WorldList[myIndex].force_no_echo = 0;
        i += 2;
      }
      break;
    case 7:
/*      if(beep_type == beep_type_speaker ||
         beep_type == beep_type_speaker + beep_type_visual)
        gdk_beep();
      if(beep_type == beep_type_visual ||
         beep_type == beep_type_speaker + beep_type_visual) {
        gtk_widget_hide(WorldList[myIndex].output_text);
        gtk_widget_show(WorldList[myIndex].output_text);
        gtk_widget_hide(WorldList[myIndex].output_text);
        gtk_widget_show(WorldList[myIndex].output_text);
        gtk_widget_hide(WorldList[myIndex].output_text);
        gtk_widget_show(WorldList[myIndex].output_text);
      }*/
      break;
    case 10:
      add_10_if_needed(myIndex);
      if(j != 0) {
        s[j] = 0;
        insert_current();
        j = 0;
      }
      WorldList[myIndex].insert_10 = 1;
      break;
    case 27:
      if(j != 0) {
        s[j] = 0;
        add_10_if_needed(myIndex);
        insert_current();
        j = 0;
      }
      i = parse(myIndex, line, i, len);
      break;
    default:
      s[j] = line[i];
      j++;
      napos++;
    }
  }
  if(j != 0) {
    s[j] = 0;
    add_10_if_needed(myIndex);
    insert_current();
  }
  g_free(s);
  if(WorldList[myIndex].locked < 1)
    gtk_adjustment_set_value(vadj, vadj->upper);
}

#define strnew(str) strcpy(g_malloc(strlen(str) + 1), str)

int parse(gint myIndex, char *s, int i, int len) {
  char *tmp;
  int *numlist = NULL;
  int numcount = 0;
  int j, k;
  
  if(s[i + 1] != '[') /* no escape code found */
    return i;
  tmp = g_malloc(len - i + 1);
  i += 2;
  for(j = 0; 1; j++) {
    if(s[j + i] == 0) {/* end of line, broken escape code ? */
  		WorldList[myIndex].ansibuffer = strnew(s + i - 2); /* now pointing at the ESC char */
      /*return i;*/ return len;          /* skipping the ramaining chars */
    } else if(s[j + i] == ';') /* one number found */
      numcount++;
    else if(s[j + i] < '0' || s[j + i] > '9') { /* last code found */
      numcount++;
      break;
    }
  }
  if(numcount != 0) 
    numlist = g_malloc(sizeof(int) * numcount);
  for(j = 0; j < numcount; j++) {
    k = 0;
    while(s[k + i] >= '0' && s[k + i] <= '9') {
      tmp[k] = s[k + i];
      k++;
    }
    tmp[k] = 0;
    i += k + 1;
    numlist[j] = atoi(tmp);
  }
  i--;
/*printf("parsing complete\n");*/
  switch(s[i]) {
  case 'm': /* A display attribute */
    for(j = 0; j < numcount; j++) {
      switch(numlist[j]) {
      case  0: /* normal    */
      	WorldList[myIndex].fgcolor = DEFAULTFG;
		WorldList[myIndex].bgcolor = DEFAULTBG;
        WorldList[myIndex].curfont = my_font;
        WorldList[myIndex].font_weight = "normal_weight";
        break;
      case  1: /* bold      */
        WorldList[myIndex].font_weight = "bold_weight";
        break;
      case  4: /* underline  *** NOT SUPPORTED *** */
        break;
      case  5: /* blink      *** NOT SUPPORTED *** */
        break;
      case  7: /* reverse    *** NOT SUPPORTED ****/
        break;
      case  8: /* invisible */
        WorldList[myIndex].fgcolor = WorldList[myIndex].bgcolor;
        break;
      case 30: /* black     */
        WorldList[myIndex].fgcolor = "black_foreground";
        break;
      case 31: /* red       */
        WorldList[myIndex].fgcolor = "red_foreground";
        break;
      case 32: /* green     */
        WorldList[myIndex].fgcolor = "green_foreground";
        break;
      case 33: /* yellow    */
        WorldList[myIndex].fgcolor = "yellow_foreground";
        break;
      case 34: /* blue      */
        WorldList[myIndex].fgcolor = "blue_foreground";
        break;
      case 35: /* magenta   */
        WorldList[myIndex].fgcolor = "magenta_foreground";
        break;
      case 36: /* cyan      */
        WorldList[myIndex].fgcolor = "cyan_foreground";
        break;
      case 37: /* white     */
        WorldList[myIndex].fgcolor = "white_foreground";
        break;
      case 40: /* black     */
        WorldList[myIndex].bgcolor = "black_background";
        break;
      case 41: /* red       */
        WorldList[myIndex].bgcolor = "red_background";
        break;
      case 42: /* green     */
        WorldList[myIndex].bgcolor = "green_background";
        break;
      case 43: /* yellow    */
        WorldList[myIndex].bgcolor = "yellow_background";
        break;
      case 44: /* blue      */
        WorldList[myIndex].bgcolor = "blue_background";
        break;
      case 45: /* magenta   */
        WorldList[myIndex].bgcolor = "magenta_background";
        break;
      case 46: /* cyan      */
        WorldList[myIndex].bgcolor = "cyan_background";
        break;
      case 47: /* white     */
        WorldList[myIndex].bgcolor = "white_background";
        break;
      }
    }
    break;
  }
  g_free(numlist);
  g_free(tmp);
  return i;
}

void limit_to_20(int for_what, gchar *from, gchar **to) {
  char *pro = NULL;
  int prelen = 0, prolen = 0;

/*printf("Startiung conversion\n");*/
  (*to)[0] = 0;
  if(strlen(from) > 20) {
    if(for_what == FOR_EDITOR) {
      pro = strrchr(from, ':');
      if(pro == NULL)
        for_what = FOR_WORLD;
      else {
        pro++;
        prolen = strlen(pro);
        prelen = pro - from - 1;
        strncpy((*to), from, 20);
        (*to)[prelen > 20 ? 20 : prelen] = 0;
/*printf("----------123456789|123456789|123456789|123456789|123456789|\n");
printf("  *to == \"%s\"\n",*to);
printf("  pro == \"%s\"\n",pro);
printf("1\n");*/
        if(20 - prolen - 4 > 0) {
/*printf("2\n");*/
          if(20 - prolen - 1  < prelen) {
/*printf("3 (starting \"...\" at pos: 20 - prolen - 4 == %d\n",20-prolen-4);*/
            strcpy((*to) + 20 - prolen - 4, "...");
/*  					(*to)[16 - prolen] = '.';
            (*to)[17 - prolen] = '.';
  					(*to)[18 - prolen] = '.';
  					(*to)[19 - prolen] = 0;*/
          }
/*else printf("4\n");*/
        } else {
/*printf("5\n");*/
          strcpy((*to), "...");
        }
/*printf("6\n");*/
        strcat((*to), ":");
        strncat((*to), pro, 20 - strlen((*to)) < prolen ? 20 - strlen((*to)) - 3 : prolen);
        if(strlen((*to)) == 17) {
          strcat((*to), "...");
        }
      }
    }
    if(for_what == FOR_WORLD) {
      strncpy((*to), from, 17);
      ((*to))[17] = 0;
      strcat((*to), "...");
    }
  } else
    strcpy((*to), from);
/*printf("   \"%s\"(%d)\n-> \"%s\"(%d)\n\n", from,strlen(from), (*to),strlen((*to)));*/
}
