#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#ifndef MainHeader
#define MainHeader 1
#define DEBUG 1

GtkWidget *main_window;
GtkWidget *about;
GtkWidget *file_open_dialog;
AtkObject *atko;
GtkWidget *main_app_dock;
GtkWidget *main_toolbar;
GtkWidget *new_world_button;
GtkWidget *open_world_button;
GtkWidget *save_world_button;
GtkWidget *world_view;
GtkWidget *io_pane;
GtkWidget *output_scroller;
GtkWidget *output_text;
GtkWidget *input_scroller;
GtkWidget *input_text;
GtkWidget *world_name;
GtkWidget *editor_scroller;
GtkWidget *editor_text_view;
GtkWidget *editor_name;
GtkWidget *status_bar;
GtkAccelGroup *accel_group;
GtkWidget *file_open_dialog;
GtkWidget *file_open_ok_button;
GtkWidget *file_open_cancel_button;
GdkColormap *my_colormap;
GdkColor black;
GdkColor white;
GdkColor yellow;
GdkColor green;
GdkColor magenta;
GdkColor cyan;
GdkColor red;
GdkColor blue;
PangoFontDescription *my_font;

#define DEFAULTFG "white_foreground"
#define DEFAULTBG "black_background"

gint WorldListIndex;
gint WorldListLength;
struct WorldData {
	GtkWidget *io_pane;
	GtkWidget *output_scroller;
	GtkWidget *output_text;
	GtkWidget *input_scroller;
	GtkWidget *input_text;
	GtkWidget *world_name;
	GtkWidget *editor_name;

	GString *DisplayName;
	GString *FileName;
	GString *WorldDomain;
	gint WorldPort;
	GString *CharacterName;
	GString *Password;
	gint AutoConnect;
	GString *WorldComment;
	GList *command_history;
	gint historyindex;
	GString *storedcommand;
	gboolean changed;
	gint WorldType;
	int sockfd;
	struct sockaddr_in my_addr;
	gint network_read_handler;
	GtkTextIter output_end_iter;
	GtkTextIter last_line_iter;
	GIOChannel *io_channel;
	gint insert_10;
	gint locked;
	gint lines_pending;
	gpointer highlites;
	PangoFontDescription *curfont;
	gchar *fgcolor;
	gchar *bgcolor;
	gchar *font_weight;
	gint highlitecount;
	gint force_no_echo;
	gchar *ansibuffer;
};

struct WorldData WorldList[32];
void catch_input (GtkTextBuffer *editable,
                        gpointer arg1,
                        gpointer new_text,
                        gint arg3,
                        gboolean arg4,
                        gpointer user_data);

	gboolean 	scroll_history 		(	GtkTextBuffer		*editable,
									GdkEvent		*Event,
									gpointer		user_data);

	void 	switch_worlds 		(	GtkNotebook		*notebook,
									GtkNotebookPage	*page,
									gint			page_num,
									gpointer		user_data);

	void	world_prop_changed	(	GtkEditable 	*editable,
									gpointer		user_data);

	void 	properties_apply	(	GnomePropertyBox *widget,
									gint 			 page,
									gpointer 		 user_data);


gboolean    network_read        (	GIOChannel *source,
                                    GIOCondition condition,
                                    gpointer data);
                                    
void create_tags(GtkTextBuffer *buffer);
void add_10_if_needed(gint myIndex);
void gM_world_print(gint myIndex, char *line, int len);
int parse(gint myIndex, char *s, int i, int len);
#define FOR_WORLD 1
#define FOR_EDITOR 2
void limit_to_20(int for_what, gchar *from, gchar **to);
#endif
